function add_all_events_global_cb(arg1,arg2)
%Function to append all the f_ext analysis events (in matrix) to the global
%list.

%Also adds some extra info per each line. Adds date (as a number) and file
%number for each event line.

%Also checks for duplicate entries, to make sure you don't add the same
%file more than once. Assumes no two entries should be identical (that
%would be extremely unlikely.

%140403 mjc

global f_ext_analysis_global_list;

ud = get(gcf,'userd');

xy = ud.fext_pairs;
[m n] = size(xy);

%Get file date and number, should be in ud.data for recently made f-ext.
%For older f-ext files grab the info from the axis title.
if isfield(ud,'data')
    nfdate = str2num(ud.data.file(1:6))
    nfnum = str2num(ud.data.file(8:10))
else
    ht = get(gca,'title');%axis title handle
    title_str = get(ht,'string');%axis title string
    %date and file number are always a fixed n characters from the end
    fdate = title_str(end-11:end-6);%string
    nfdate = str2num(fdate);%converted to a number
    
    fnum = title_str(end-3:end-1);%string
    nfnum = str2num(fnum);%converted to a number
end

%replicate the numbers to append to the right hand side of the xy matrix
date_num_mat = repmat([nfdate nfnum],m,1);

%append to xy matrix
xy = [xy date_num_mat];

%now check if the global list is empty
if isempty(f_ext_analysis_global_list)
    f_ext_analysis_global_list = xy;%done
else
    %check the current list to see if this file is already included
    rep_file = sum(f_ext_analysis_global_list(:,8) == nfdate & f_ext_analysis_global_list(:,9) == nfnum);
    
    if rep_file > 0
        msgbox('File appears to already be in the global list (file date/number match found).')
        return
    else %append
        f_ext_analysis_global_list = [f_ext_analysis_global_list; xy]
        
    end
    
end

list_files_in_global_cb
