function xy = add_f_ext_pairs_cb(arg1,arg2)
%This version is for the right click callback

%choose set of points
%you must add points as pairs. Should click points in time order for both
%opening and closing (pulling and relaxing too). I.e., for pulling and an opening event,
% the first click is when it started opening, the second when it finished
% (initial and final config).

%to add individual points (specifying what the point means), use the
%function: add_f_ext_points

%usually better to just add in pairs

%press enter to stop adding pairs

%indicate with 'pull_relax' input whether the data is for pulling or
%relaxing: odd = pull, even = relax (use trace #)

%using to manually indicate opening/closing forces-extensions
%140402 mjc

ud = get(gcf,'UserData');%empty to start

if isfield(ud,'fext_pairs')
    xy = ud.fext_pairs;
else
    xy = [];
end

%figure out which trace this is

%handles of all lines plotted, list is reverse order of plotting (newest
%first), so 1st is the model
hlines = findall(gca,'Type','line');

%reverse and remove model
hlines = flipud(hlines(2:end));
%get trace #
ntrace = find(hlines == gco)

tag = get(hlines(ntrace),'tag');
%pr = mod(floor(pull_relax),2) == 1

go = 1;
while go
    [x1 y1 button1] = ginput(1);%click for initial config
    
    if isempty(button1) %this mean enter was pressed, to stop clicking
        go = 0;
    else
        h1 = plot(x1,y1,'gx','linew',2,'markersize',10,'tag',tag);
        
        [x2 y2 button2] = ginput(1);%click for final config
        
        if isempty(button2) %this means enter was pressed, to stop clicking, so we don't have a pair then, ignore first plot
            delete(h1);%erase the previous marker
            go = 0;
        else %now we have both points
            h2 = plot(x2,y2,'rx','linew',2,'markersize',10,'tag',tag);
            
            %add to list of points
            
            %coords and plot handle of p1 and p2, pull/relax # (odd should
            %be a pull, even a relaxation)
            xy = [xy;[x1 y1 h1 x2 y2 h2 ntrace]];
            
        end
        
    end
    
end

ud.fext_pairs = xy;

set(gcf,'userd',ud);




