function combine_traces_cb(arg1,arg2)
%Take a set of f-ext curves that have been separated (offset in ext) and
%remove the offsets (so they are overlayed again). Adjusts the f-ext
%traces and the associated event markers and data.

%140411 mjc

ud = get(gcf,'UserData');

N = length(ud.hlines);%number of traces

for i = 1:N
    %offset the f-ext line and any data plot associated with the line (all
    %have same tag in axis)
    tag = get(ud.hlines(i),'tag');
    hall = findobj('parent',gca,'tag',tag);%for this axis, the line and all the markers tagged like it
    
    o = -ud.trace_offsets(i);
    for h = hall'
        ext = get(h,'xdata');
        set(h,'xdata',ext+o);
    end
    
end

if isfield(ud,'fext_pairs')
    %correct ext values in open/close event data (offset ext the same amount)
    corrections = -ud.trace_offsets(ud.fext_pairs(:,7));%says which line, thus how much the offset is
    ud.fext_pairs(:,1) = ud.fext_pairs(:,1) + corrections;% x1
    ud.fext_pairs(:,4) = ud.fext_pairs(:,4) + corrections;% x2
end

ud.trace_offsets = zeros(N,1);

axis tight

set(gcf,'userd',ud);