function remove_f_ext_pairs_cb(arg1,arg2)
%menu click function to delete clostest even pair from f-ext list.
%the f-ext usually have multiple traces that overlap annoyingly
%so should only consider pairs associated with the curve you selected the
%menu from

%140403 mjc

ud = get(gcf,'UserData');

if isfield(ud,'fext_pairs')
    xy = ud.fext_pairs;
    if isempty(xy)
        msgbox('Nothing to delete')
        return;%nothing to delete
    end
else
    msgbox('Nothing to delete')
    return;%nothing to delete
end

%figure out which trace this is
hlines = ud.hlines;
ntrace = find(hlines == gco);

%select the data just from the given trace
%mask the full list: multiply the other data by zero to ignore 

%vector of rows that match the trace
xy_vec = xy(:,7) == ntrace;

%make mask
xy_mask = repmat(xy_vec,1,7);

xy_masked = xy.*xy_mask;

if sum(xy_masked(:)) == 0 %no events for that trace
    msgbox('No events for this trace.')
    return;%nothing to delete
end

go = 1;
while go
    [x1 y1 button1] = ginput(1);%click for initial config
    
    if isempty(button1) %this means enter was pressed, to stop clicking
        go = 0;
    else %we have a click
        %find closest peaks
        p1_dist = sqrt((x1-xy_masked(:,1)).^2 + (y1-xy_masked(:,2)).^2);
        p2_dist = sqrt((x1-xy_masked(:,4)).^2 + (y1-xy_masked(:,5)).^2);
        dist_sum = p1_dist+p2_dist;
        
        [m ind] = min(dist_sum);
        
        delete([xy(ind,3) xy(ind,6)]);%delete markers from plot
        xy(ind,:) = [];%delete corresponding row from matrix
        xy_masked(ind,:) = [];
        
        ud.fext_pairs = xy;
        %update figure data now, in case an error later
        set(gcf,'userd',ud);
        
        if isempty(xy) | sum(xy_masked(:)) == 0
            return
        end
    end
    
end
              
        

