function separate_traces_cb(arg1,arg2)
%Take a set of f-ext curves that are overlayed and re-plot them offset in
%ext in order to see them better. Keeps track of the offsets so that you
%can revert back to the overlay later. Also shifts the analysis plots and
%data.

%140411 mjc

ud = get(gcf,'UserData');

global offset_ext
if isempty(offset_ext)
    offset_ext = 50;
end

N = length(ud.hlines);%number of traces
newoffsets = ((1:N)-1)*offset_ext;

ud.trace_offsets = ud.trace_offsets + newoffsets';

for i = 1:N
    %offset the f-ext line and any data plot associated with the line (all
    %have same tag in axis)
    tag = get(ud.hlines(i),'tag');
    hall = findobj('parent',gca,'tag',tag);%for this axis, the line and all the markers tagged like it
    
    o = newoffsets(i);
    for h = hall'
        ext = get(h,'xdata');
        set(h,'xdata',ext+o);
    end
    
end

axis tight

if isfield(ud,'fext_pairs')
    %correct ext values in open/close event data (offset ext the same amount)
    corrections = ((ud.fext_pairs(:,7)-1)*offset_ext);%says which line, thus how much the offset is
    ud.fext_pairs(:,1) = ud.fext_pairs(:,1) + corrections;% x1
    ud.fext_pairs(:,4) = ud.fext_pairs(:,4) + corrections;% x2
end

set(gcf,'userd',ud);
