function data = downsample_all_trap_data(data,factor)
%downsample all data associated with the trap and update sampling period
%value.  Most appropriately called right after opening the data.  Leaves
%fluorescence data alone.  Also only changes for 2 traps (A, B, ignores
%possiblility of C).
%111202 mjc

%140204 mjc - Was ignoring the FB data, now including that for usual
%configuration of FB X and Sum

data.sampperiod = data.sampperiod*factor;

data.A_Y = downsample(data.A_Y,factor);
data.A_X = downsample(data.A_X,factor);
data.B_Y = downsample(data.B_Y,factor);
data.B_X = downsample(data.B_X,factor);
data.A_FB_X = downsample(data.A_FB_X,factor);
data.B_FB_X = downsample(data.B_FB_X,factor);

data.A_Sum = downsample(data.A_Sum,factor);
data.B_Sum = downsample(data.B_Sum,factor);
data.A_FB_Sum = downsample(data.A_FB_Sum,factor);
data.B_FB_Sum = downsample(data.B_FB_Sum,factor);

data.trappos1 = downsample(data.trappos1,factor);
data.trappos2 = downsample(data.trappos2,factor);

end
