function CalibrateCont

D = datevec(date);

Date = [num2str(D(1)-2000,'%02d') num2str(D(2),'%02d') num2str(D(3),'%02d')];

global datadirectories 
global mostrecentcal

startpath = [datadirectories Date '\'];

F = dir([startpath '*.dat']);

if isempty(F)
    return
end

rootfile = [F(end).name(1:10) '.dat'];

calfilename = ['cal' rootfile(1:10)];%this is to be sure to not get confused by the fl files


if evalin('base',['~exist(''' calfilename ''')']) && evalin('base',['~exist(''' ['data_' rootfile(1:10)] ''')'])
    %try to open the file, will fail if still writing to file
    try
        
        fid = fopen([startpath rootfile],'r','ieee-be');
        nheader = fread(fid,1,'float64');
        version = fread(fid,1,'float64');%file version
        data.rawperiod = fread(fid,1,'float64');%raw sampling period of data before averaging for saving (s)
        sampperiod = fread(fid,1,'float64');%sampling period of data (s)
        nchannels = fread(fid,1,'float64');%number of data channels
        chanpattern = fread(fid,1,'float64');%channel pattern identifier (e.g., 1 trap or two)
        datatype = fread(fid,1,'float64');%data type identifier (1 = calibration, 0 = time series, 2 = raster scan)
        fclose(fid);
    catch
        return
    end
    
    fnumber = str2double(rootfile(8:10));
    
    if datatype == 1 %a cal file
       
        CalibrateStrippedWrapper(Date,rootfile);
        mostrecentcal = str2double(rootfile(8:10));
        
    elseif datatype == 3 %a fluorescence map        
        try
            fplot_fluor_map(Date,rootfile);
            saveas(gcf,[startpath rootfile(1:10) '_image.fig']);
        catch
            assignin('base',['data_' rootfile(1:10)],1);
            return
        end
        
    elseif datatype == 2 %a raster scan, use offset, don't run on offset
        if fnumber - mostrecentcal > 1
            try
                plot_trapraster(Date,mostrecentcal,mostrecentcal+1,fnumber);
                saveas(gcf,[startpath rootfile(1:10) '_fext.fig']);
                
%                 plot_fluor_time_series(Date,mostrecentcal,mostrecentcal+1,fnumber)
                
            catch
                assignin('base',['data_' rootfile(1:10)],1);
                return
            end
        end
        
    else
        assignin('base',['data_' rootfile(1:10)],1);
    end


end

% end