function plot_qpd_time_series(param)
%plot just qpd data vs time (for testing purposes)

global fbslash %/ or \
global datadirectories

%% parameters
if nargin == 0
    Date = '131118';
    datafilenumber = 95;
    
else
    Date = param.Date;
    datafilenumber = param.datafilenumber;
    
end

startpath = [datadirectories Date fbslash];

rootfile = [Date '_' num2str(datafilenumber,'%03d') '.dat'];
datafilename = ['data_' rootfile(1:(end-4))];

%% get data
data = ReadMattFile_Wrapper(startpath,rootfile);

%% analyze the data a little
A_sum_mean = mean(data.A_Sum);
A_FB_mean = -mean(data.A_FB_Sum);
% intensity_mean = mean(data.A_Sum);
% psd_mean = mean(data.C_Y_Sum);
A_X_norm_mean = mean(data.A_X./data.A_Sum)
A_Y_norm_mean = mean(data.A_Y./data.A_Sum)

average_factor = 10;

time = downsample(data.time,average_factor);
% C_Y_Sum = downsample(data.C_Y_Sum,average_factor);
A_Sum = downsample(data.A_Sum,average_factor);
A_X = downsample(data.A_X,average_factor)
A_Y = downsample(data.A_Y,average_factor)
A_FB_Sum = -downsample(data.A_FB_Sum,average_factor);

%% plot data
% figure('position',[ 1000         578         905         760])
figure('position',[1000         362        1003         976])
hold on

% plot(time,C_Y_Sum/psd_mean,'r');
subplot(2,1,1)
plot(time,A_Sum/A_sum_mean,'r','linewidth', 1.5);
title(['Trap QPD Sum (No FB) (' Date '\_' num2str(datafilenumber,'%03d') ')'])
ylabel('Relative Intensity')
subplot(2,1,2)
%plot(time,A_FB_Sum/A_FB_mean,'b','linewidth', 1.5);
plot(time,A_FB_Sum/A_FB_mean,'b','linewidth', 1.5);
% ylabel('Relative Intensity')
ylabel('Relative Intensity')

title(['Feedback QPD Sum (' Date '\_' num2str(datafilenumber,'%03d') ')'])
%legend({'Fiber output' 'Fiber input'},'Location','best')

xlabel('Time (s)')

