function plot_trapraster(Date,calfilenumber,offsetfilenumber,datafilenumber)
%script to analyze raster scan data simply
%100303 mjc

%modified to add data to main figure and add the new f-ext analysis menus
%140411 mjc

global fbslash
global datadirectories
global fltestdir
global laptop

    construct = 'hairpin-RH-dT-19';
% construct = 'hairpin-LH-dT-40-RH0'; %for mtDNA helicase, hp seq1-40dT
% construct = 'hairpin-LH-dT-40-RH19'; %for mtDNA helicase, hp seq1-40dT
%  construct = 'hairpin-LH-dT-80-RH0'; %for mtDNA helicase, hp seq2-80dT
%  construct = 'hairpin-RH-dT-38';
%  construct = 'hairpin-RH-dT-60';
%  construct = 'RNA-hairpin-1';
% construct = 'oligo';
% construct = 'no_tether';
%  construct = 'SSB1';
%  construct = 'CTD';
%  construct = 'T4';%3.4 kb dsDNA
%  construct = 'dsDNA_2kb';
% construct = 'nucleosome';
% construct = 'dt14fret';
% construct = 'fret601';
%   construct = 'YAPcc Pulling';

dsample_trap = 4;
dsample_offset = 4;

%% initialize
if nargin == 0;
    Date = '140410';
    calfilenumber = 221;
    offsetfilenumber =  [];
    datafilenumber = 223;
end

Savefigdir = [datadirectories Date '\'];

%best to define a force range for the fit (do so for each case below)
fit_force_range = [];%if this is empty, continues to use the old indice method of defining fit interval
show_force_range = 1;
fit_first_relaxation = 0;
switch construct
    case 'oligo'
        hairpin = 0;
        dna1label = 'Oligo Binding DNA Model';
        ssDNA1 = 19;
        dsDNA1 = 3.258e3;
        %         dna2label = 'Hairpin Open Model';
        %         dsDNA2 = 3.05e3;
        %         ssDNA2 = 201;
        fitoffset = 1;
        fitrange = 700:1000;
        fakeoffset = 0;
    case 'no_tether'
        hairpin = 0;
        dna1label = 'No tether';
        ssDNA1 = 19;
        dsDNA1 = 3.258e3;
        %         dna2label = 'Hairpin Open Model';
        %         dsDNA2 = 3.05e3;
        %         ssDNA2 = 201;
        fitoffset = 0;
        fitrange = 700:1000;
        fakeoffset = 0;
    case 'fret601'
        fit_first_relaxation = 1;
        hairpin = 0;
        dna1label = 'FRET 601 DNA Model';
        ssDNA1 = 0;
        dsDNA1 = 3.4e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 201;
        fitoffset = 1;
        fitrange = 200:350;
        fakeoffset = 0;
    case 'SSB1'
        fit_first_relaxation = 1;
        hairpin = 0;
        dna1label = 'SSB Binding DNA Model';
        ssDNA1 = 70;
        dsDNA1 = 3.25e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 201;
        fitoffset = 1;
        fitrange = 200:350;
        fakeoffset = 0;
    case 'CTD'
        fit_first_relaxation = 1;
        hairpin = 0;
        dna1label = 'CTD + DNA Model';
        ssDNA1 = 0;
        dsDNA1 = 3.25e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 201;
        fitoffset = 1;
        fitrange = 200:350;
        fakeoffset = 0;
        
    case 'hairpin-RH-dT-19'
        hairpin = 1;
        dna1label = 'Hairpin Closed Model';
        ssDNA1 = 19;
        dsDNA1 = 3.05e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 201;
        fitoffset = 1;
        fit_force_range = [4 8];%(pN)
        fitrange = 500:1500;
        fakeoffset = 0;
        
    case 'hairpin-LH-dT-40-RH0'
        hairpin = 1;
        dna1label = 'Hairpin Closed Model';
        ssDNA1 = 40;
        dsDNA1 = 3.05e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
%         dsDNA2 = 1.5e3;
        ssDNA2 = 2*89+4+40; %222, goes with 'hp seq1-40dT'
%         ssDNA2 = 1.5e3; %222, goes with 'hp seq1-40dT'
        fitoffset = 1;
        fitrange = 300:400;
        fakeoffset = 0;
        
    case 'hairpin-LH-dT-80-RH0'
        hairpin = 1;
        dna1label = 'Hairpin Closed Model';
        ssDNA1 = 80;
        dsDNA1 = 3.05e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
%         dsDNA2 = 1.5e3;
        ssDNA2 = 2*69+4+80; %222, goes with 'hp seq1-40dT'
%         ssDNA2 = 1.5e3; %222, goes with 'hp seq1-40dT'
        fitoffset = 1;
        fitrange = 600:700;
        fakeoffset = 0;
        
     case 'hairpin-LH-dT-40-RH19'
        hairpin = 1;
        dna1label = 'Hairpin Closed Model';
        ssDNA1 = 40+19;
        dsDNA1 = 3.05e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
%         dsDNA2 = 1.5e3;
        ssDNA2 = 2*89+4+40+19; %222, goes with 'hp seq1-40dT'
%         ssDNA2 = 1.5e3; %222, goes with 'hp seq1-40dT'
        fitoffset = 1;
        fitrange = 300:400;
        fakeoffset = 0;
        
    case 'RNA-hairpin-1'
        %the first RNA hairpin
        hairpin = 1;
        dna1label = 'Hairpin Closed Model';
        ssDNA1 = 6;
        dsDNA1 = 3.05e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 2*16+4+ssDNA1; 
        fitoffset = 1;
        fitrange = 400:500;
        fakeoffset = 0;
    case 'hairpin-RH-dT-38'
        hairpin = 1;
        dna1label = 'Hairpin Closed Model';
        ssDNA1 = 38;
        dsDNA1 = 3.05e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 2*89+4+38;%220
        fitoffset = 1;
        fitrange = 200:350;
        fakeoffset = 0;
    case 'hairpin-RH-dT-60'
        hairpin = 1;
        dna1label = 'Hairpin Closed Model';
        ssDNA1 = 60;
        dsDNA1 = 3.05e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 2*89+4+38;%220
        fitoffset = 1;
        fitrange = 200:350;
        fakeoffset = 0;
        
    case 'nucleosome'
        hairpin = 1;
        dna1label = 'Wrapped Nucleosome Model';
        dsDNA1 = 1.687e3+1.7e3;
        ssDNA1 = 0;
        dna2label = '100 bp Unwrapped Nucleosome Model';
        dsDNA2 = 1.687e3+1.7e3+100;
        ssDNA2 = 0;
        fitoffset = 0;
        fitrange = 200:350;
        fakeoffset = 70;
    case 'T4'
        hairpin = 0;
        %         dsDNA = 1.5e3;%first try
        %         dsDNA1 = 3011+29+120;%second try, ds part + overhang + stuck part
        dsDNA1 = 3.4e3;
        ssDNA1 = 0;
        fitoffset = 1;
        fitrange = 600:900;
        fakeoffset = 0;
    case 'dsDNA_2kb'
        hairpin = 0;
        %         dsDNA = 1.5e3;%first try
        %         dsDNA1 = 3011+29+120;%second try, ds part + overhang + stuck part
        dsDNA1 = 2.2e3;
        ssDNA1 = 0;
        fitoffset = 1;
        fitrange = 500:600;
        fakeoffset = 0;
    case 'dt14fret'
        hairpin = 0;
        dsDNA1 = 1.7e3+1.5e3;
        ssDNA1 = 16;
        fitoffset = 1;
        fitrange = [];
        fakeoffset = 50;
        
        % hairpin = 0;
        % dsDNA = 3.4e3;
        % ssDNA = 0;
     case 'YAPcc Pulling'
        hairpin = 0;
        %         dsDNA = 1.5e3;%first try
        %         dsDNA1 = 3011+29+120;%second try, ds part + overhang + stuck part
        dsDNA1 = 3.32e3;
        ssDNA1 = 10;
        fitoffset = 1;
        fitrange = 500:600;
        fakeoffset = 0;
end

if isempty(offsetfilenumber)
    offsetfilenumber = calfilenumber + 1;
    %offsetfilenumber = [];%not usual! remove this later! 131122 mjc
end


if isempty(datafilenumber)
    datafilenumber = calfilenumber + 2;
end

plotcomments = {''};

startpath = [datadirectories Date fbslash];

rootfile = [Date '_' num2str(datafilenumber,'%03d') '.dat'];

calrootfile = [Date '_' num2str(calfilenumber,'%03d') '.dat'];

calfilename = ['cal' calrootfile(1:(end-4))];

datafilename = ['data_' rootfile(1:(end-4))];

%% get calibration
eval(['global ' calfilename]);

calexist = evalin('base',['exist(''' calfilename ''')']);

if ~calexist%then do calibration
    
    CalibrateStrippedWrapper(Date,calrootfile);
    
    cal = evalin('base',calfilename);
    
else
    cal = evalin('base',calfilename);
end

%% get data
data1 = ReadMattFile_Wrapper(startpath,rootfile);

data1 = downsample_all_trap_data(data1,dsample_trap);

%% analyze raster
%get offset data
if ~isempty(offsetfilenumber) %if use offset file
    offsetrootfile = [Date '_' num2str(offsetfilenumber,'%03d') '.dat'];
    offsetdata = ReadMattFile_Wrapper(startpath,offsetrootfile);
    offsetdata = downsample_all_trap_data(offsetdata,dsample_offset);
    offsetdata = separate_raster_data(offsetdata);
    %take mean of multiple scans (uncalibrated)
    offset.axoffraw = mean(offsetdata.A_X);
    offset.ayoffraw = mean(offsetdata.A_Y);
    offset.bxoffraw = mean(offsetdata.B_X);
    offset.byoffraw = mean(offsetdata.B_Y);
    offset.nu = offsetdata.nu;
    offset.nudelta = offsetdata.nudelta;
    
    data = trapraster(data1,cal,fakeoffset,offset);
else %don't use offset file
    data = trapraster(data1,cal,fakeoffset);
end

N = data.nscanfb * 2;%total number of scans (forward + backward)

data.meanforcedata = mean(abs(data.B_FX) + abs(data.A_FX))/2;

colors = lines(N);

%% plot f vs nu
if 0
    figure('Position',[ 2674         491         975         634])
    set(gcf,'Pos',[ 2613         311         975        1024])
    for j = 1:N
            subplot(2,1,1)
            plot(data.nudelta,(abs(data.A_FX(j,:))+abs(data.B_FX(j,:)))/2,'Color',colors(j,:));
            ylabel('Force (pN)')
            title(['Force vs. Extension, ' num2str(fakeoffset) ' nm offset (' Date '\_' num2str(datafilenumber) ')'])
            hold on;
            legendstr{j} = num2str(j);
%             plot(data.nudelta,data.A_Sum(j,:)-mean(data.A_Sum(j,:)),'Color',colors(j,:));
%         subplot(2,1,1)
%         plot(-data.nudelta+data.t1x,data.A_Sum(j,:),'Color',colors(j,:));
%         hold on;
%         %     plot(data.nudelta,data.B_Sum(j,:)-mean(data.B_Sum(j,:)),'Color',colors(j,:));
%         plot(-data.nudelta+data.t1x,data.B_Sum(j,:),'Color',colors(j,:));
%         ylabel('Y\_Sum (V)')
%         title(['Trap Intensity vs Trap Position, ' num2str(fakeoffset) ' nm offset (' Date '\_' num2str(datafilenumber) ')'])
% 
%         subplot(2,1,2)
%         plot(-data.nudelta+data.t1x,data.A_FB_Sum(j,:),'Color',colors(j,:));
%         hold on;
%              plot(data.nudelta,data.B_Sum(j,:)-mean(data.B_Sum(j,:)),'Color',colors(j,:));
%         plot(-data.nudelta+data.t1x,data.B_FB_Sum(j,:),'Color',colors(j,:));
%         xlabel(['Trap Frequency \Delta (MHz)'])
%         ylabel('Y\_FB\_Sum (V)')
    end
    
    for j = 1:N
        plot(data.nudelta,(abs(data.A_FX(j,:))+abs(data.B_FX(j,:)))/2,'Color',colors(j,:));
        
    end
    
    subplot(2,1,2)
    plot(offset.nudelta,(offset.axoffraw-mean(offset.axoffraw))*cal.alphaAX,'k');
    hold on
    plot(offset.nudelta,(offset.ayoffraw-mean(offset.ayoffraw))*cal.alphaAY+4,'r');
    plot(offset.nudelta,(offset.bxoffraw-mean(offset.bxoffraw))*cal.alphaBX+8,'b');
    plot(offset.nudelta,(offset.byoffraw-mean(offset.byoffraw))*cal.alphaBY+12,'g');
    legend({'AX Offset' 'AY Offset' 'BX Offset' 'BY Offset'})
    
    % plot traps separately
    % figure('Position',[ 2674         491         975         634])
    % plot(data.nudelta,data.A_Xcal(1,:),'k');
    % hold on;
    % % plot(data.nudelta,data.A_Xcal(2,:),'r');
    %
    % plot(data.nudelta,data.B_Xcal(1,:));
    % % plot(data.nudelta,data.B_Xcal(2,:)),'g';
    %
    % legend({'A_X' 'B_X'})
    %
    xlabel(['Trap Frequency \Delta (MHz)'])
    ylabel('QPD (nm)')
end

%% model

if 0
    %plot to see indices to choose fit range
    figure
    plot((abs(data.A_FX(1,:))+abs(data.B_FX(1,:)))/2);
end

if fitoffset == 1
    data.beadsep = data.beadsep - fakeoffset;%remove fake offset
    if fit_first_relaxation == 0
        fitforce = (abs(data.A_FX(1,:))+abs(data.B_FX(1,:)))/2;%first pull
    else
        fitforce = (abs(data.A_FX(2,:))+abs(data.B_FX(2,:)))/2;%first relaxation (good for SSB data)
    end
    if isempty(fit_force_range)
        %then use indices in fitrange
        if isempty(fitrange) %unless it is empty, then use the whole data range
            fitrange = 1:length(fitforce);
        end
    else %use the specified force range
        %find indices to match force range (rough since force is noisy)
        fitrange = t_int2ind(fitforce,fit_force_range);%returns indices between endpoints      
    end
    fakeoffset = fminsearch(@(o) sum((construct_ext(dsDNA1,ssDNA1,fitforce(fitrange)) - (data.beadsep(1,fitrange) + o)).^2),75);
    data.beadsep = data.beadsep + fakeoffset;%add fit offset
    data.beadsep_onlyX = data.beadsep_onlyX + fakeoffset;%add fit offset
end

data.meanbeadsep = mean(data.beadsep);

F = (abs(data.A_FX(1,:))+abs(data.B_FX(1,:)))/2;
fitforce2 = min(F):0.1:max(F);

if hairpin == 1;
    %closed hairpin
    totalextcl = construct_ext(dsDNA1,ssDNA1,fitforce2);
    
    %open hairpin
    totalextop = construct_ext(dsDNA2,ssDNA2,fitforce2);    
else
    dsdnaext = dsDNA1*0.34*XWLCContour2(fitforce2);
    ssdnaext = ssDNA1*0.59*XWLCContour2(fitforce2,1);
    
    totalext = dsdnaext + ssdnaext;
end

%% plot F vs ext., all curves
% legendstr = {};
% figure('Position',[4   310   786   651])
% set(gcf,'FileName',[Savefigdir Date '_' num2str(datafilenumber)]);
% set(gcf,'Name',[Date '_' num2str(datafilenumber) ' force vs. extension']);
% for j = 1:N
%     plot(data.beadsep(j,:),(abs(data.A_FX(j,:))+abs(data.B_FX(j,:)))/2,'Color',colors(j,:));
%     hold on;
%     legendstr{j} = num2str(j);
% end
%
% plot(totalext,fitforce,'k--','LineWidth',2);
% j = j+1;legendstr{j} = '3.2 kbp + 19 nt model';

% plot(zhi_hairpin_fext(:,1)+140,zhi_hairpin_fext(:,2),'r');
% j = j+1;legendstr{j} = 'Zhi Hairpin';
%
% legend(legendstr,'Location','NorthWest')
%
% xlabel(['Bead Separation (nm)'])
% ylabel('Force (pN)')
% title(['Force vs. Extension, ' num2str(fakeoffset) ' nm offset (' Date '\_' num2str(datafilenumber) ')'])

%% plot extension vs time
% figure('Position',[630   291   832   634])
% set(gcf,'FileName',[Savefigdir Date '_' num2str(datafilenumber)]);
% set(gcf,'Name',[Date '_' num2str(datafilenumber) ' extension vs. time']);

% plot(data.beadsep(1,:))

%% plot mean f-ext with model (main plot)
% figure('Position',[804          77        1090         886])
if laptop == 1
%     figure('Position',[447         105        1050         859])
    figure('Position',[293    51   832   634])
else
    figure('Position',[ 2674         491         975         634])
end
set(gcf,'FileName',[Savefigdir Date '_' num2str(datafilenumber,'%03d')]);
set(gcf,'Name',[Date '_' num2str(datafilenumber,'%03d') ' force vs. extension']);
ud.data = data;
ud.ntraces = N;

hold on
%plot(mean(data.beadsep),data.meanforcedata,'b.','LineWidth',2);
hlines = [];%handles of line plots for menu items later
ext_offset = 0;%if you want to offset each trace in ext
ud.trace_offsets = [];
for j = 1:N
    troff = (j-1)*ext_offset;
    ud.trace_offsets = [ud.trace_offsets; troff];
    hl = plot(data.beadsep(j,:)+troff,(abs(data.A_FX(j,:))+abs(data.B_FX(j,:)))/2,'Color',colors(j,:));
    hold on
    hlines = [hlines; hl];
    hold on;
%     plot(data.beadsep_nooffcurve(j,:)+troff,(abs(data.A_FX_nooffcurve(j,:))+abs(data.B_FX_nooffcurve(j,:)))/2,'r');
%     plot(data.beadsep_onlyX_nooffcurve(j,:)+troff,(abs(data.A_FX_nooffcurve(j,:))+abs(data.B_FX_nooffcurve(j,:)))/2,'k');
%     plot(data.beadsep(j,:),abs(data.A_FY_nooffcurve(j,:)),'Color','r');
%     plot(data.beadsep(j,:),abs(data.B_FY_nooffcurve(j,:)),'Color','k');
    legendstr{j} = num2str(j);
end

% plot models
if hairpin == 1
    plot(totalextcl,fitforce2,'r:','LineWidth',1.5);
    plot(totalextop,fitforce2,'k:','LineWidth',1.5);
    legendstr{j+1} = dna1label;
    legendstr{j+2} = dna2label;
    ud.nfittraces = 2;
else
    plot(totalext,fitforce2,'r.','LineWidth',2);
    legendstr{j+1} = 'Model';
    ud.nfittraces = 1;
end

% plot again in magenta the range used for the fit - for diagnostics
m = plot(data.beadsep(1,fitrange)+troff,(abs(data.A_FX(1,fitrange))+abs(data.B_FX(1,fitrange)))/2,'m');
set(m,'HandleVisibility','off','HitTest','off','vis','off','tag','fitrange');%to keep from interferring with menu analysis
ud.hfitrange = m;

legend(legendstr,'Location','NorthWest')
xlabel('Tether Extension (nm)')
ylabel('Force (pN)')
if fitoffset == 1
    title(['Force vs. Extension, ' num2str(fakeoffset,'%3.0f') ' nm fit offset (' Date '\_' num2str(datafilenumber,'%03d') ')'])
else
    title(['Force vs. Extension, ' num2str(fakeoffset) ' nm offset (' Date '\_' num2str(datafilenumber,'%03d') ')'])
end

ud.hlines = hlines;
set(gcf,'userdata',ud);

%% add menus for f-ext analysis (opening/closing events)
set_contextmenu_fext(hlines);

%% plot fit residuals
% figure
% hold on
% plot(fitforce,totalext-data.beadsep(1,:),'b.')
% dsx = 20;
% plot(downsample(fitforce,dsx),downsample(totalext-data.beadsep(1,:),dsx),'k.'

%% finish
assignin('base',datafilename,data);
