function plot_trapraster(Date,calfilenumber,offsetfilenumber,datafilenumber)
%script to analyze raster scan data simply
%100303 mjc
global fbslash
global datadirectories
% global fltestdir
global laptop

%construct = '3.4kb';%3.401 kb dsDNA, MSU test construct
% construct = 'hairpin-RH-dT-19';
% construct = 'hairpin-RH-dT-38';
% construct = 'hairpin-RH-dT-60';
construct = 'oligo';
%  construct = 'SSB1';
%  construct = 'CTD';
% construct = 'nucleosome';
% construct = 'dt14fret';
% construct = 'fret601';

dsample_trap = 1;
dsample_offset = 20;

%times to take a subset of data for the offset
offsettimes = [1.36 5];%for file 48, this is first pass, looks good
scantimes = [6 8.3];%scan of interest

%% initialize
if nargin == 0;
    Date = '140212';
    calfilenumber =    6;
    offsetfilenumber =  [];%if = [] then no offset, if = 0 then assume cal# + 1
    datafilenumber =    48;%9 for AOM f-ext, 44 for a fishing trace
end

invertY = 1;%should be true for 2D Y pulling with AOD

Savefigdir = [datadirectories Date '\'];

fit_first_relaxation = 0;
switch construct
    case '3.4kb'
        hairpin = 0;
        dsDNA1 = 3.401e3;
        ssDNA1 = 0;
        fitoffset = 1;
        fitrange = 700:1000;
        fakeoffset = 0;
    case 'oligo'
        hairpin = 0;
        dna1label = 'Oligo Binding DNA Model';
        ssDNA1 = 19;
        dsDNA1 = 3.258e3;
        %         dna2label = 'Hairpin Open Model';
        %         dsDNA2 = 3.05e3;
        %         ssDNA2 = 201;
        fitoffset = 1;
        fitrange = 300:450;
        fakeoffset = 0;
    case 'fret601'
        fit_first_relaxation = 1;
        hairpin = 0;
        dna1label = 'FRET 601 DNA Model';
        ssDNA1 = 0;
        dsDNA1 = 3.4e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 201;
        fitoffset = 1;
        fitrange = 200:350;
        fakeoffset = 0;
    case 'SSB1'
        fit_first_relaxation = 1;
        hairpin = 0;
        dna1label = 'SSB Binding DNA Model';
        ssDNA1 = 70;
        dsDNA1 = 3.25e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 201;
        fitoffset = 1;
        fitrange = 200:350;
        fakeoffset = 0;
    case 'CTD'
        fit_first_relaxation = 1;
        hairpin = 0;
        dna1label = 'CTD + DNA Model';
        ssDNA1 = 0;
        dsDNA1 = 3.25e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 201;
        fitoffset = 1;
        fitrange = 200:350;
        fakeoffset = 0;
        
    case 'hairpin-RH-dT-19'
        hairpin = 1;
        dna1label = 'Hairpin Closed Model';
        ssDNA1 = 19;
        dsDNA1 = 3.05e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 201;
        fitoffset = 1;
        fitrange = 300:400;
        fakeoffset = 0;
    case 'hairpin-RH-dT-38'
        hairpin = 1;
        dna1label = 'Hairpin Closed Model';
        ssDNA1 = 38;
        dsDNA1 = 3.05e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 2*89+4+38;%220
        fitoffset = 1;
        fitrange = 200:350;
        fakeoffset = 0;
    case 'hairpin-RH-dT-60'
        hairpin = 1;
        dna1label = 'Hairpin Closed Model';
        ssDNA1 = 60;
        dsDNA1 = 3.05e3;
        dna2label = 'Hairpin Open Model';
        dsDNA2 = 3.05e3;
        ssDNA2 = 2*89+4+38;%220
        fitoffset = 1;
        fitrange = 200:350;
        fakeoffset = 0;
        
    case 'nucleosome'
        hairpin = 1;
        dna1label = 'Wrapped Nucleosome Model';
        dsDNA1 = 1.687e3+1.7e3;
        ssDNA1 = 0;
        dna2label = '100 bp Unwrapped Nucleosome Model';
        dsDNA2 = 1.687e3+1.7e3+100;
        ssDNA2 = 0;
        fitoffset = 0;
        fitrange = 200:350;
        fakeoffset = 70;
    case 'dt14fret'
        hairpin = 0;
        dsDNA1 = 1.7e3+1.5e3;
        ssDNA1 = 16;
        fitoffset = 1;
        fitrange = [];
        fakeoffset = 50;
        % hairpin = 0;
        % dsDNA = 3.4e3;
        % ssDNA = 0;
end

if offsetfilenumber == 0
    offsetfilenumber = calfilenumber + 1;
end

if isempty(datafilenumber)
    datafilenumber = calfilenumber + 2;
end

plotcomments = {''};

startpath = [datadirectories Date fbslash];

rootfile = [Date '_' num2str(datafilenumber,'%03d') '.dat'];

calrootfile = [Date '_' num2str(calfilenumber,'%03d') '.dat'];

calfilename = ['cal' calrootfile(1:(end-4))];

datafilename = ['data_' rootfile(1:(end-4))];



%% get calibration
eval(['global ' calfilename]);

calexist = evalin('base',['exist(''' calfilename ''')']);

if ~calexist%then do calibration
    
    CalibrateStrippedWrapper(Date,calrootfile);
    
    cal = evalin('base',calfilename);
    
else
    cal = evalin('base',calfilename);
end

%hack cal
% cal.alphaBX
% cal.kappaBX
%
% cal.alphaBX = 3200;
% cal.kappaAX = 1;
% cal.kappaBX = 1;



%% get trap data
data = ReadMattFile_Wrapper(startpath,rootfile);
data = downsample_all_trap_data(data,dsample_trap);

if invertY %for pulling in Y with AOD, should invert Y
    data.A_Y = -data.A_Y;
    data.B_Y = -data.B_Y;
end

%% analyze raster
%get offset data
if ~isempty(offsetfilenumber) %if use offset file
    offsetrootfile = [Date '_' num2str(offsetfilenumber,'%03d') '.dat'];
    offsetdata = ReadMattFile_Wrapper(startpath,offsetrootfile);
    offsetdata = downsample_all_trap_data(offsetdata,dsample_offset);
    offsetdata = separate_raster_data(offsetdata);
    %take mean of multiple scans (uncalibrated)
    offset.axoffraw = mean(offsetdata.A_X);
    offset.ayoffraw = mean(offsetdata.A_Y);
    offset.bxoffraw = mean(offsetdata.B_X);
    offset.byoffraw = mean(offsetdata.B_Y);
    offset.nu = offsetdata.nu;
    
    data = trapraster(data1,cal,fakeoffset,offset);
end

%find subinterval indices

%get offset sub data
[m offset_t1_i] = min(abs(data.time - offsettimes(1)));
[m offset_t2_i] = min(abs(data.time - offsettimes(2)));
offset_i = [offset_t1_i:offset_t2_i];

%get selected scan sub data
[m scan_t1_i] = min(abs(data.time - scantimes(1)));
[m scan_t2_i] = min(abs(data.time - scantimes(2)));
scan_i = [scan_t1_i:scan_t2_i];



%calibrate

%first remove the offset data using the offset scan

%get offset data sub selection
ds = 4;
offset.nu = downsample(data.trappos1(offset_i),ds);
axoffraw = downsample(data.A_X(offset_i),ds);
ayoffraw = downsample(data.A_Y(offset_i),ds);
bxoffraw = downsample(data.B_X(offset_i),ds);
byoffraw = downsample(data.B_Y(offset_i),ds);

%get scan sub selection
data.nu = data.trappos1(scan_i);
axraw = data.A_X(scan_i);
ayraw = data.A_Y(scan_i);
bxraw = data.B_X(scan_i);
byraw = data.B_Y(scan_i);
t1pos = data.trappos1(scan_i);%MHz
t2pos = data.trappos2(scan_i);

AA_AODcal = 947;%nm/MHz, Jess's AA AOD cal, ~6x the AOM cal

trapDmhz = t1pos - t2pos;%MHz
trapDnm = trapDmhz * AA_AODcal;%nm

trap1nm = (t1pos - 28) * AA_AODcal;%the 28 is the center, arbitrary
trap2nm = (t2pos - 28) * AA_AODcal;

%interpolate to match data scan values

intmethod = 'linear';
axoffi = interp1(offset.nu,axoffraw,data.nu,intmethod);
ayoffi = interp1(offset.nu,ayoffraw,data.nu,intmethod);
bxoffi = interp1(offset.nu,bxoffraw,data.nu,intmethod);
byoffi = interp1(offset.nu,byoffraw,data.nu,intmethod);

%create calibrated position data
if 1
    ax = axraw-axoffi;
    ay = ayraw-ayoffi;
    bx = bxraw-bxoffi;
    by = byraw-byoffi;
    
    data.A_Xcal = ax*cal.alphaAX;
    data.A_Ycal = ay*cal.alphaAY;
    data.B_Xcal = bx*cal.alphaBX;
    data.B_Ycal = by*cal.alphaBY;
else %else use the single calibration offset value
    data.A_Xcal = (data.A_X-cal.AXoffset)*cal.alphaAX;
    data.A_Ycal = (data.A_Y-cal.AYoffset)*cal.alphaAY;
    data.B_Xcal = (data.B_X-cal.BXoffset)*cal.alphaBX;
    data.B_Ycal = (data.B_Y-cal.BYoffset)*cal.alphaBY;
end

%create calibrated force data
data.A_FX = data.A_Xcal*cal.kappaAX;
data.A_FY = data.A_Ycal*cal.kappaAY;
data.B_FX = data.B_Xcal*cal.kappaBX;
data.B_FY = data.B_Ycal*cal.kappaBY;

data.meanforcedata = mean(abs(data.B_FX) + abs(data.A_FX))/2;

%calculate bead separation data
data.A_Xabs = data.A_Xcal;
data.A_Yabs = data.A_Ycal + trap1nm;

data.B_Xabs = data.B_Xcal;
data.B_Yabs = data.B_Ycal + trap2nm;

data.beadsep = sqrt((data.A_Xabs - data.B_Xabs).^2 + (data.A_Yabs - data.B_Yabs).^2) - cal.beadA/2 - cal.beadB/2 + fakeoffset;

%% plot F-ext only
if 1
    % figure('Position',[804          77        1090         886])
    if laptop == 1
        figure('Position',[447         105        1050         859])
    else
        figure('Position',[630   291   832   634])
    end
    set(gcf,'FileName',[Savefigdir Date '_' num2str(datafilenumber,'%03d')]);
    set(gcf,'Name',[Date '_' num2str(datafilenumber,'%03d') ' force vs. extension']);
    
    plot(data.beadsep,data.A_FY,'b')
    hold on
    plot(data.beadsep,-data.B_FY,'r')
    plot(data.beadsep,(data.A_FY-data.B_FY)/2,'k')
    
    legendstr = {'Trap 1' 'Trap 2' 'Mean'}
    legend(legendstr,'Location','NorthWest')
    xlabel('Tether Extension (nm)')
    ylabel('Force (pN)')
    
    if fitoffset == 1
        title(['Force vs. Extension, ' num2str(fakeoffset,'%3.0f') ' nm fit offset (' Date '\_' num2str(datafilenumber,'%03d') ')'])
    else
        title(['Force vs. Extension, ' num2str(fakeoffset) ' nm offset (' Date '\_' num2str(datafilenumber,'%03d') ')'])
    end
    
end

%% plot position vs time
if 1
figure

plot(data.time,data.A_Y(:),'b');
hold on
plot(data.time,data.B_Y(:),'r');

xlabel(['Time (s)'])
ylabel('Force (pN)')
title(['Force vs. Extension, ' num2str(fakeoffset) ' nm offset (' Date '\_' num2str(datafilenumber) ')'])
legend({'Trap 1' 'Trap 2'})
end

%% plot force vs trap position
if 0
figure
plot(data.trappos1,(abs(data.A_FX(:))+abs(data.B_FX(:)))/2,'k');
hold on
plot(data.trappos1,abs(data.A_FX(:)),'b');
plot(data.trappos1,abs(data.B_FX(:)),'r');

xlabel(['Trap 1 Frequency (MHz)'])
ylabel('Force (pN)')
title(['Force vs. Extension, ' num2str(fakeoffset) ' nm offset (' Date '\_' num2str(datafilenumber) ')'])
legend({'Mean force' 'Trap 1' 'Trap 2'})
end

%% plot position vs trap position
if 0
figure

plot(data.trappos1,data.A_Y(:),'b');
hold on
plot(data.trappos1,data.B_Y(:),'r');
plot(data.trappos1(offset_t1_i:offset_t2_i),data.B_Y(offset_t1_i:offset_t2_i),'g');
plot(data.trappos1(offset_t1_i:offset_t2_i),data.A_Y(offset_t1_i:offset_t2_i),'g');



xlabel(['Trap 1 Frequency (MHz)'])
ylabel('Force (pN)')
legend({'Trap 1' 'Trap 2'})
title(['Force vs. Extension, ' num2str(fakeoffset) ' nm offset (' Date '\_' num2str(datafilenumber) ')'])
end

%% plot only offset and selected trace position vs trap position
if 1
figure

%y position measurements - direction of pulling for AOD test
subplot(2,2,1)
plot(data.trappos1(offset_t1_i:offset_t2_i),data.A_Y(offset_t1_i:offset_t2_i),'b');
hold on
plot(data.trappos1(offset_t1_i:offset_t2_i),data.B_Y(offset_t1_i:offset_t2_i),'b');

plot(data.trappos1(scan_t1_i:scan_t2_i),data.B_Y(scan_t1_i:scan_t2_i),'g');
plot(data.trappos1(scan_t1_i:scan_t2_i),data.A_Y(scan_t1_i:scan_t2_i),'g');

%plot the offset subtracted data
plot(data.nu,ay,'r')
plot(data.nu,by,'r')

xlabel(['Trap 1 Frequency (MHz)'])
ylabel('Y Position (mV)')
title(['Force vs. Extension, ' num2str(fakeoffset) ' nm offset (' Date '\_' num2str(datafilenumber) ')'])
legend({'Trap 1 offset' 'Trap 2 offset' 'Trap 1 scan' 'Trap 2 scan' 'Trap 1 scan offset subtracted' 'Trap 2 scan offset subtracted'})

%cal y position measurements
% subplot(2,2,3)
% plot(data.nu,-data.A_Ycal,'b')
% hold on
% plot(data.nu,data.B_Ycal,'k')
% xlabel('Trap 1 Frequency (MHz)')
% ylabel('Y Position (nm)')

%cal y force measurements
subplot(2,2,3)
plot(data.nu,data.A_FY,'b')
hold on
plot(data.nu,-data.B_FY,'k')
xlabel('Trap 1 Frequency (MHz)')
ylabel('Y Force (pN)')

%x position measurements - usual direction of AOM pulling
subplot(2,2,2)
plot(data.trappos1(offset_t1_i:offset_t2_i),data.A_X(offset_t1_i:offset_t2_i),'b');
hold on
plot(data.trappos1(offset_t1_i:offset_t2_i),data.B_X(offset_t1_i:offset_t2_i),'b');

plot(data.trappos1(scan_t1_i:scan_t2_i),data.B_X(scan_t1_i:scan_t2_i),'g');
plot(data.trappos1(scan_t1_i:scan_t2_i),data.A_X(scan_t1_i:scan_t2_i),'g');

%plot the offset subtracted data
plot(data.nu,ax,'r')
plot(data.nu,bx,'r')

xlabel(['Trap 1 Frequency (MHz)'])
ylabel('X Position (mV)')

%force extension
subplot(2,2,4)
plot(data.beadsep,data.A_FY,'b')
hold on
plot(data.beadsep,-data.B_FY,'r')
plot(data.beadsep,(data.A_FY-data.B_FY)/2,'k')

legendstr = {'Trap 1' 'Trap 2' 'Mean'}
legend(legendstr,'Location','NorthWest')
xlabel('Tether Extension (nm)')
ylabel('Force (pN)')

end





%% finish
assignin('base',datafilename,data);
